using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.ProgramResource.Cqrs;

public class GetProgramResourceByIdResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetProgramResourceByIdQuery(string Id) : IRequest<GetProgramResourceByIdResponse?>;

public class GetProgramResourceByIdHandler : IRequestHandler<GetProgramResourceByIdQuery, GetProgramResourceByIdResponse?>
{
    private readonly AppDbContext _context;

    public GetProgramResourceByIdHandler(AppDbContext context) => _context = context;

    public async Task<GetProgramResourceByIdResponse?> Handle(GetProgramResourceByIdQuery request, CancellationToken cancellationToken)
    {
        return await _context.ProgramManagerResource
            .AsNoTracking()
            .Where(x => x.Id == request.Id)
            .Select(x => new GetProgramResourceByIdResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy
            })
            .FirstOrDefaultAsync(cancellationToken);
    }
}